#!/bin/bash

# Atualiza distribuição do MEC, Linux Educacional 1.0
# que é uma versão unstable do Debian 4 (etch) para
# a versão estável.
#
# Autor: Valerio F. Laube  - ( vflaube@gmail.com )
# Versão: .01                  Data : outubro/2007
# Licença: CC-GPL
# 


#### funções  #################################################################################################

    
    cria_sources_list_internet()
    {
          # Criando sources.list para atualização via Internet
          cp /etc/apt/sources.list  /etc/apt/sources.list.original
          rm -rf /etc/apt/sources.list
          echo '## Repositorios Debian Stable - Escolha um ou mais retirando o caracter #' > /etc/apt/sources.list
          echo 'deb ftp://ftp.debian.org/debian stable main contrib non-free' >> /etc/apt/sources.list
          echo '#deb http://ftp.br.debian.org/debian stable main contrib non-free' >> /etc/apt/sources.list
          echo '#deb http://ftp.br.debian.org/debian stable main contrib non-free' >> /etc/apt/sources.list
          echo '#deb http://ftp.uk.debian.org/debian stable main contrib non-free' >> /etc/apt/sources.list
          echo '#deb http://ftp2.de.debian.org/debian stable main contrib non-free' >> /etc/apt/sources.list
          echo '#deb http://ftp.cl.debian.org/debian stable main contrib non-free' >> /etc/apt/sources.list
          echo '#deb http://ftp.fr.debian.org/debian stable main contrib non-free' >> /etc/apt/sources.list
          echo '#deb http://ftp.it.debian.org/debian stable main contrib non-free' >> /etc/apt/sources.list
          echo '#deb http://ftp.is.debian.org/debian stable main contrib non-free' >> /etc/apt/sources.list
          echo '#deb http://ftp.es.debian.org/debian stable main contrib non-free' >> /etc/apt/sources.list
          echo '#deb http://ftp.hu.debian.org/debian stable main contrib non-free' >> /etc/apt/sources.list
          echo '#deb http://ftp.us.debian.org/debian stable main contrib non-free' >> /etc/apt/sources.list
          echo ' ' >> /etc/apt/sources.list
          echo '## Atualizações de Segurança para Debian - Stable' >> /etc/apt/sources.list
          echo 'deb http://security.debian.org/ stable/updates main contrib non-free' >> /etc/apt/sources.list
          echo ' ' >> /etc/apt/sources.list
          echo '# mirrors multimidia' >> /etc/apt/sources.list
          echo 'deb http://www.debian-multimedia.org etch main' >> /etc/apt/sources.list
     }




################## Principal ##################################################
clear
echo '-----------------------------------------------------------------'
echo 'Script de atualização do Linux Educacional 1.0'
echo '                    Autor: Valerio F. Laube - vflaube@gmail.com'
echo '                    Versão: .01             Data : outubro/2007'
echo '                    Licença: CC-GPL'
echo '-----------------------------------------------------------------'
echo 'Requisitos:'
echo ' - Se for necessário atualizar via Internet, o Computador deve '
echo '   estar conectado à mesma sem proxy'
echo ' - Script deve ser executado como usuário root'
echo '-------------------------------------------------------------------'
echo ' '
sleep 2

# Testar se o usuario atual é root

if [ "$USER" != 'root' ] 
   then 
        echo ' '
        echo '*******************************************************************'
        echo 'ATENÇÃO !!!!'
        echo 'Este script deverá ser executado somente pelo usuário root ' 
        echo 'Para isso use o comando 'su' forneça a senha do root e execute'
        echo 'novamente este script.                      Fechando...' 
        echo '*******************************************************************'
        sleep 5 
        exit
fi

# Verificando se existe repositorio local e/ou copia local do cache de outra máquina

if [ -f copia_cache/Packages.gz ]
  then
     echo ':::::::::::::::::::::::::::::::::::::::::::::::::::::::'
     echo '  Configurando repositório local'
     echo ':::::::::::::::::::::::::::::::::::::::::::::::::::::::'
     # Salvando sources.list atual
     mv -v /etc/apt/sources.list /etc/apt/sources.list.bk
     echo ':::::: Gerando sources.list para instalação local ::::::::::::::'
     caminho=`pwd`
     # cria novo arquivo 'sources.list' no diretorio /etc/apt
     touch /etc/apt/sources.list
     # insere o repositorio na primeira linha do arquivo 'sources.list'
     echo 'deb file:$caminho copia_cache/' |  tee -a /etc/apt/sources.list

  else
      echo 'Não foi encontrado repositório local. Procurando por cópia de cache...'
      # Verifica se existe cópia do cache de outra máquina
      if [ -d copia_cache ]
      then
	  echo ':::::: Cópia de cache encontrada. Copiando... ::::::::::::::'
          cp -v -u copia_cache/*  /var/cache/apt/archives/	
          echo ' '
          echo ':::::: Ajustando sources.list... ::::::::::::::'
          cria_sources_list_internet
          echo '------------------------------------------------'
      else
          echo '-----------------------------------------------------------------------------------'
          echo 'Não foi encontrado repositório e nem cache local.'
          echo 'Todos os arquivos deverão ser baixados da Internet, o que consumirá bastante tempo'
          echo '-----------------------------------------------------------------------------------'
          echo ' '     
          echo 'Configurando para atualização através da Internet'
          echo '-----------------------------------------'
          cria_sources_list_internet
          echo ' '
      fi
fi

# gpg key para repositórios Debian Multimedia
# wget http://www.debian-multimedia.org/gpgkey.pub
# apt-key add apoio/gpgkey.pub
# aptitude update




echo '-----------------------------------'
echo 'Atualizando base do APT e keyrings'
echo '-----------------------------------'
aptitude update
aptitude install debian-multimedia-keyring
aptitude update

echo '--------------------------'
echo 'Atualizando a distribuição'
echo '--------------------------'
aptitude -y dist-upgrade

#echo '---------------------------------------------------------------------'
#echo 'Instalando bibliotecas adicionais sugeridas pelo Adept apos o upgrade'
#echo '---------------------------------------------------------------------'
aptitude install -y libavcodeccvs51 libavformatcvs51 libavutilcvs49 libfaac0 libfaad0 liblame0 libpostproccvs51 libx264-54 libxvidcore4


echo '-------------------------------------------------------------------------'
echo 'Infelizmente não dá para atualizar o w32codecs e mplayer, e se removê-los'
echo 'desinstalará centenas de arquivos dependentes de mec-desktop.            '
echo 'Deixando as versões antigas e cruzando os dedos ...                      '
echo '-------------------------------------------------------------------------'
echo ' '
                    
echo 'Aguarde.. Fazendo verificações finais.' 

# configura todos os pacotes que eventualmente só estejam parcialmente instalados
dpkg --configure -a 
   
# para resolver eventual problema de integridade dos pacotes
apt-get -f install  

echo ' '
echo '---------------------------------------------------------'
echo 'É necessário reiniciar para ativar todas as atualizações'
echo '---------------------------------------------------------'
echo ' '

echo '**************** CONCLUIDO *****************'

sleep 100


# Meta pacote mec-desktop
#kdeedu, gcompris, mec-artwork-kdm, mec-artwork-usplash, mec-default-settings, kanagram, tuxpaint, drgeo, chemtool,
#            qliss3d, tuxmath, kuser, alsa-base, alsa-utils, cdrdao, cupsys, cupsys-bsd, cupsys-client, #cupsys-driver-gutenprint,
#            discover, dvd+rw-tools, eject, iceweasel-l10n-pt-br, flashplayer-mozilla, sun-java5-plugin, #foomatic-db-engine,
#            foomatic-db-gutenprint, foomatic-filters-ppds, hal, libdvdcss2, libterm-readline-gnu-perl, libtheora0, #printconf,
#            sun-java5-fonts, sun-java5-jre, w32codecs, x-window-system-core, manpages-pt, ibrazilian, aspell-pt-br, #wbrazilian,
#            util-linux-locales, broffice.org, openoffice.org-java-common, libgnome2-0, desktop-file-utils, sharutils, #lzop, rpm, arj,
#            p7zip-full, lha, bzip2, unrar, hdparm, mozilla-mplayer, dosfstools, adept, amarok, kaffeine, ark, arts,
#            gtk2-engines-gtk-qt, k3b, k3b-i18n, kaudiocreator, kaddressbook, kcalc, kcontrol, kdepasswd, kde-i18n-ptbr, #kdeprint,
#            kdesktop, kdm, kedit, kdnssd, kfloppy, khelpcenter, kicker, klipper, kmail, kmilo, kmix, knetworkconf, #konqueror,
#            konsole, kontact, kooka, kopete, korganizer, kpdf, kscreensaver, ksmserver, ksplash, ksvg, ksysguard, #ksystemlog, kwin,
#            openoffice.org-kde, konqueror-nsplugins, kwalletmanager, kdeadmin-kfile-plugins, kdebase-kio-plugins,
#            kdegraphics-kfile-plugins, kdemultimedia-kfile-plugins, kdemultimedia-kio-plugins, kdenetwork-kfile-plugins,
#            konq-plugins, digikam, kipi-plugins, kuser, zip, lame, kmplayer-plugin
#Descrição: Linux Educacional meta-package





